unit MenuFrame;

interface uses Forms, Controls, Graphics, Windows, Messages,
  SysUtils, Classes, SyncObjs, InGlobal, IWControl, IWHTMLControls,
  IWCompButton, IWCompLabel, IWAppForm, IWContainer, IWRegion,
  IWBaseControl, IWCompMenu, Menus, ImgList, IWImageList, IWColor, IWTypes,
  IWVCLBaseControl, IWBaseHTMLControl, IWVCLBaseContainer, IWHTMLContainer,
  IWHTML40Container, IWCompExtCtrls, IWApplication, IWCompText, IWCompFlash,
  IWCompRectangle, IWTMSButton, IWAdvMessageDialog, IWCompEdit, IWTMSCtrls,
  IWCompProgressBar, IWBaseComponent, IWBaseHTMLComponent,
  IWBaseHTML40Component, IWCompCheckbox, IWCompListbox;

type
  TModalResultEvent = procedure(Sender: TObject; ModalResult: TModalResult) of object;

const AbortRetryIgnore_btn = 0; OK_btn = 1; OKCancel_btn = 2;
  RetryCancel_btn = 3; YesNo_btn = 4; YesNoCancel_btn = 5; YesNoAll_btn = 6;
  YesNoAllCancel_btn = 7; OkAll_btn = 8; OKCancelDetails_btn = 9;
  YesNoDetails_btn = 10; YesNo_btn2 = 11;

  Warn = $0000; Error = $0001; Inform = $0002; Confirm = $0003;       {msg_type}
  ODS_error=$0004;

type
  TMenuFram = class(TFrame)
      MainMenu: TMainMenu;          IWFrameRegion: TIWRegion;   Menu: TIWMenu;
      FileMenu: TMenuItem;          Open: TMenuItem;            Import: TMenuItem;    Retrieve: TMenuItem;        Export: TMenuItem;
      ViewMessagesNew: TMenuItem;   ViewMessagesOld: TMenuItem; ImportAllReferenceTables: TMenuItem;
      ViewChangeLog: TMenuItem;     N1: TMenuItem;              ExportAllReferenceTables: TMenuItem;
      FileExitItem: TMenuItem;      SubappMenu: TMenuItem;      RefreshTablesParams: TMenuItem;
      ParametersMenu: TMenuItem;    SalaryMenu: TMenuItem;      SyncTablesAndParams: TMenuItem;
      MaintainSal: TMenuItem;       ComputeSal: TMenuItem;      SetMaximum: TMenuItem;
      ActivateSalary1: TMenuItem;   ActivateSalary2: TMenuItem; SalDirectory: TMenuItem;
      ImportPayTables: TMenuItem;   ImportPayRecs: TMenuItem;   ExportPayTables: TMenuItem;
      AccountsMenu: TMenuItem;      ToolsMenu: TMenuItem;       Update: TMenuItem;
      Generate: TMenuItem;          MultiplySubap: TMenuItem;   Distribute: TMenuItem;
      Delete: TMenuItem;            TransferBud: TMenuItem;
      Edit: TMenuItem;              NewEmpStep: TMenuItem;      N6: TMenuItem;
      ReportDirectory: TMenuItem;   FontDirectory: TMenuItem;   NewReport: TMenuItem;
      NewZoneReport: TMenuItem;     NewText: TMenuItem;         RangesDirectory: TMenuItem;
      OptionsMenu: TMenuItem;       Versions: TMenuItem;        RefTableOptions: TMenuItem;      UserOptions: TMenuItem;     SourceOfData: TMenuItem;
      Password: TMenuItem;          UserFields: TMenuItem;      GeneralComments: TMenuItem;
      Color: TMenuItem;             AdvancedMenu: TMenuItem;    ANSICharacters: TMenuItem;
      BrowserFields: TMenuItem;     WebBrowserFields: TMenuItem;InstallHeading: TMenuItem;
      Home1: TMenuItem;             N9: TMenuItem;              SubapSingleUserMode: TMenuItem;
      UserCounts: TMenuItem;        ActiveUserList: TMenuItem;  SingleUserModeAllSubapps: TMenuItem;
      BroadcastMessage: TMenuItem;  N10: TMenuItem;             ForceOtherstoClose: TMenuItem;
      FileUsage: TMenuItem;         RebuildData: TMenuItem;     RebuildVersionDirectory: TMenuItem;
      RebuildSystemFile: TMenuItem; N8: TMenuItem;              RebuildControlFile: TMenuItem;
      RebuildAllFiles: TMenuItem;   ArchiveScenario: TMenuItem; RebuildReportDirectory: TMenuItem;
      RestoreScenario: TMenuItem;   Backup: TMenuItem;          Restore: TMenuItem;
      ReptDirImFil: TIWImageFile;   OtherExpImFil: TIWImageFile;EmployeeImFil: TIWImageFile;
      PositionImFil: TIWImageFile;  RevenueImFil: TIWImageFile; BudExpImFil: TIWImageFile;
      BudRevImFil: TIWImageFile;    NewReptImFil: TIWImageFile; ExportImFil: TIWImageFile;
      ImportImFil: TIWImageFile;    TransferImFil: TIWImageFile;BrowseImFil: TIWImageFile;
      SearchImFil: TIWImageFile;    TotalsImFil: TIWImageFile;  ChooseImFil: TIWImageFile;
      OpenImFil: TIWImageFile;      InitValsImFil: TIWImageFile;UserLab: TIWLabel;
      LoginBtn: TIWButton;          HelpImFil: TIWImageFile;
      Security: TMenuItem;          InstallAccounts: TMenuItem; AdvMessageDial1: TTIWAdvMessageDialog;
      InstallSubAccounts: TMenuItem;InstallBenefits: TMenuItem; AdvMessageDial2: TTIWAdvMessageDialog;
      InstallMiscFields: TMenuItem; InstallWeb: TMenuItem;      InstallRemapAccounts: TMenuItem;
      InstallOther: TMenuItem;      PeriodNames: TMenuItem;     InstallRemapSubAccounts: TMenuItem;
      CancelInstallMode: TMenuItem; InstallReport: TMenuItem;   InstallReportOptions: TMenuItem;   
      InstallMode: TMenuItem;       CurrentBenefits: TMenuItem; ImageList1: TImageList;
      TitleLab: TIWLabel;           UserNameLab: TIWLabel;      ExitBtn: TIWButton;
      ModalWin: TIWModalWindow;     ModalLab: TIWLabel;         SelCodeWin: TIWModalWindow;
      SelCodeReg: TIWRegion;        TopReg: TIWRegion;          DescrCB: TIWCheckBox;
      SelectLB: TIWListbox;         SelRefTitleLab: TIWLabel;

    procedure WindowDoOnAsyncClick(Sender: TObject; EventParams: TStringList);

    procedure show_MessageDlg(AMsg: AnsiString; Amsg_type, AButtons: integer;
      AfixedFont: boolean; AMsgHandler: TModalResultEvent; AHelpCtx: longint);
    procedure show_ok(s: AnsiString; msg_type: word; AMsgHandler: TModalResultEvent);
    procedure show_ok_fixed_font(s: AnsiString; msg_type: word; AMsgHandler: TModalResultEvent);
    procedure show_y_and_n(s: AnsiString; msg_type: word;
      AMsgHandler: TModalResultEvent);
    procedure show_ok_and_cancel(s: AnsiString; msg_type: word;
      AMsgHandler: TModalResultEvent);
    procedure show_y_n_all_and_cancel(s: AnsiString; msg_type: word;
      AMsgHandler: TModalResultEvent);
    procedure show_y_n_and_all(s: AnsiString; msg_type: word; AfixedFont: boolean;
      AMsgHandler: TModalResultEvent);
    procedure show_y_n_and_cancel(s: AnsiString; msg_type: word;
      AMsgHandler: TModalResultEvent);
    procedure show_ok_cancel_and_details(s: AnsiString; msg_type: word;
      AfixedFont: boolean; AMsgHandler: TModalResultEvent);

  public
      buttonsw: integer; MsgHandlerw: TModalResultEvent;

  end;

implementation uses IWInit, IWForm, IWServer, ServerController,
  UserSessionUnit;

{$R *.dfm}

{$I nMenuMsg.inc}

end.
