{nMenuMsg.inc}

{   procedure show_MessageDlg(AMsg: AnsiString; Amsg_type, AButtons: integer;
      AfixedFont: boolean; AMsgHandler: TModalResultEvent; AHelpCtx: longint);
    procedure show_ok(s: AnsiString; msg_type: word; AMsgHandler: TModalResultEvent);
    procedure show_ok_fixed_font(s: AnsiString; msg_type: word; AMsgHandler: TModalResultEvent);
    procedure show_y_and_n(s: AnsiString; msg_type: word;
      AMsgHandler: TModalResultEvent);
    procedure show_ok_and_cancel(s: AnsiString; msg_type: word;
      AMsgHandler: TModalResultEvent);
    procedure show_y_n_all_and_cancel(s: AnsiString; msg_type: word;
      AMsgHandler: TModalResultEvent);
    procedure show_y_n_and_all(s: AnsiString; msg_type: word; AfixedFont: boolean;
      AMsgHandler: TModalResultEvent);
    procedure show_y_n_and_cancel(s: AnsiString; msg_type: word;
      AMsgHandler: TModalResultEvent);
    procedure show_ok_cancel_and_details(s: AnsiString; msg_type: word;
      AfixedFont: boolean; AMsgHandler: TModalResultEvent);
}
{******************************}
procedure TMenuFram.WindowDoOnAsyncClick(Sender: TObject; EventParams: TStringList);
    var Resultw: TModalResult; begin
  Resultw := mrNone;
  with ModalWin do case buttonsw of
    OK_btn: Resultw := mrOk;
    OkAll_btn: case ButtonIndex of 1: Resultw := mrOk;
                                   2: Resultw := mrAll; end;
    OKCancel_btn: case ButtonIndex of 1: Resultw := mrOk;
                                      2: Resultw := mrCancel; end;
    OKCancelDetails_btn: case ButtonIndex of 1: Resultw := mrOk;
                                             2: Resultw := mrCancel;
                                             3: Resultw := mrClose{mrDetails};end;
    YesNo_btn: case ButtonIndex of 1: Resultw := mrYes;
                                   2: Resultw := mrNo; end;
    YesNoCancel_btn: case ButtonIndex of 1: Resultw := mrYes;
                                         2: Resultw := mrNo;
                                         3: Resultw := mrCancel; end;
    YesNoAll_btn: case ButtonIndex of 1: Resultw := mrYes;
                                      2: Resultw := mrNo;
                                      3: Resultw := mrAll; end;
    YesNoDetails_btn: case ButtonIndex of 1: Resultw := mrYes;
                                          2: Resultw := mrNo;
                                          3: Resultw := mrClose{mrDetails}; end;
    YesNoAllCancel_btn: case ButtonIndex of 1: Resultw := mrYes;
                                            2: Resultw := mrNo;
                                            3: Resultw := mrAll;
                                            4: Resultw := mrCancel; end;
    RetryCancel_btn: case ButtonIndex of 1: Resultw := mrRetry;
                                         2: Resultw := mrCancel; end;
    AbortRetryIgnore_btn: case ButtonIndex of 1: Resultw := mrAbort;
                                              2: Resultw := mrRetry;
                                              3: Resultw := mrIgnore; end; end;
  UserSession.modal_resp := Resultw;
  if Assigned(MsgHandlerw) then
    MsgHandlerw(nil,Resultw);
  end;

{******************************}
procedure TMenuFram.show_MessageDlg(AMsg: AnsiString; Amsg_type, AButtons: integer;
      AfixedFont: boolean; AMsgHandler: TModalResultEvent; AHelpCtx: longint);
  var j1, j2, CR_count, spacew, startw: integer; s1: shortString;
    showw: boolean; begin

  with ModalWin, Buttons do begin  Reset; HelpContext := AHelpCtx;

    Top := 50;

    with ModalLab do begin Width := 390; Height := 30;
      if length(AMsg)<60 then NoWrap := true; end;
    CR_count := 0; startw := 1;
    Autosize := true; SizeUnit := suPixel; WindowWidth := 400;
    ContentElement := ModalLab; {IWRegion1 shows blank screen}
    ModalLab.Caption := AMsg;
    WindowHeight := 150;

    case Amsg_type of                     Warn:      Title := 'Warning';
      Inform:    Title := 'Information';  Error:     Title := 'Error';
      Confirm:   Title := 'Confirmation'; ODS_error: Title := 'ODS Error';
    else         Title := ''; end;
    buttonsw := AButtons;
    case buttonsw of
      OK_btn:              CommaText := '&OK';
      OkAll_btn:           CommaText := '&OK,&All';
      OKCancel_btn:        CommaText := '&OK,&Cancel';
      OKCancelDetails_btn: CommaText := '&OK,&Cancel,&Details';
      YesNo_btn:           CommaText := '&Yes,&No';
      YesNoCancel_btn:     CommaText := '&Yes,&No,&Cancel';
      YesNoAll_btn:        CommaText := '&Yes,&No,&All';
      YesNoDetails_btn:    CommaText := '&Yes,&No,&Details';
      YesNoAllCancel_btn:  CommaText := '&Yes,&No,&All,&Cancel';
      RetryCancel_btn:     CommaText := '&Retry,&Cancel';
      AbortRetryIgnore_btn: CommaText := '&Abort,&Retry,&Ignore'; end;

    if AHelpCtx>0 then CommaText := CommaText + ',&Help';
    MsgHandlerw := AMsgHandler;
    OnAsyncClick := WindowDoOnAsyncClick;
    Show;
    end; end;

{******************************}
procedure TMenuFram.show_ok(s: AnsiString; msg_type: word; AMsgHandler: TModalResultEvent);
  begin
  if not assigned(AMsgHandler) then
    WebApplication.ShowMessage(s)
  else show_MessageDlg(s,msg_type,Ok_btn,false{FixedFont},AMsgHandler,0{help});
  end;

procedure TMenuFram.show_ok_fixed_font(s: AnsiString; msg_type: word; AMsgHandler: TModalResultEvent); begin
  show_MessageDlg(s,msg_type,Ok_btn,true{FixedFont},AMsgHandler,0{help}); end;

{******************************}
procedure TMenuFram.show_y_and_n(s: AnsiString; msg_type: word;
    AMsgHandler: TModalResultEvent); begin
  show_MessageDlg(s,msg_type,YesNo_btn,false{FixedFont},AMsgHandler,0{help});end;

procedure TMenuFram.show_ok_and_cancel(s: AnsiString; msg_type: word;
    AMsgHandler: TModalResultEvent); begin
  show_MessageDlg(s,msg_type,OKCancel_btn,false{FixedFont},AMsgHandler,0{help});
  end;

procedure TMenuFram.show_y_n_all_and_cancel(s: AnsiString; msg_type: word;
    AMsgHandler: TModalResultEvent); begin
  show_MessageDlg(s,msg_type,YesNoAllCancel_btn,false{FixedFont},AMsgHandler,0{help});
  end;

procedure TMenuFram.show_y_n_and_all(s: AnsiString; msg_type: word; AfixedFont: boolean;
    AMsgHandler: TModalResultEvent); begin
  show_MessageDlg(s,msg_type,YesNoAll_btn,AfixedFont,AMsgHandler,0{help});
  end;

procedure TMenuFram.show_y_n_and_cancel(s: AnsiString; msg_type: word;
    AMsgHandler: TModalResultEvent); begin
  show_MessageDlg(s,msg_type,YesNoCancel_btn,false{FixedFont},AMsgHandler,0{help});
  end;

procedure TMenuFram.show_ok_cancel_and_details(s: AnsiString; msg_type: word;
    AfixedFont: boolean; AMsgHandler: TModalResultEvent); begin
  show_MessageDlg(s,msg_type,OkCancelDetails_btn,AfixedFont,AMsgHandler,0{help});
  end;

