unit npRef1; {copyright (c) 2020 Old Dominion Solutions, Inc.}
interface uses IWAppForm, IWApplication, IWTypes, Classes, Controls, IWControl,
  IWWebGrid, IWAdvWebGrid, IWCompButton, IWCompListbox, SysUtils,
  IWCompLabel, ImgList, IWBaseControl, IWAdvMessageDialog, 
  IWVCLBaseControl, IWBaseHTMLControl, Vcl.Forms, MenuFrame, IWCompCheckbox,
  IWVCLBaseContainer, IWContainer, IWHTMLContainer, IWHTML40Container, IWRegion;

type
  TRefsForm = class(TIWAppForm)     ItemsAdvGrid: TTIWAdvWebGrid;          GridReg: TIWRegion;
    TopReg: TIWRegion;
    MenuMen: TMenuFram;
    BottomReg: TIWRegion;
    AllCB: TIWCheckBox;
    OKBtn: TIWButton;
    CancelBtn: TIWButton;
    PrintBtn: TIWButton;
    DeleteBtn: TIWButton;
    ImportBtn: TIWButton;
    ExportBtn: TIWButton;
    DoneBtn: TIWButton;
    procedure IWAppFormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure OKBtn_handler(Sender: TObject; ModalResult: TModalResult);
    procedure get_ver_authorization_web;
    procedure get_ver_authorization_loop;
    procedure get_ver_authorization_ButtonClick(Sender: TObject;
        ButtonIndex: Integer; InputString, InputPassword: string;
        InputCheck: Boolean; var Allow: Boolean);
    procedure Trans_Handler(Sender: TObject);
  public
    AuthHandler: TNotifyEvent;
    end;

{--------------------------------Pos. Category----------------------------------
          <XXXXXXXX><XXXXXXXX><XXXXXXXX><XXXXXXXX><XXXXXXXX><XXXXXXXX><XXXXXXXX>
   Desc   Short Inc    Amount  Amount-2  Amount-3  Amount-4    Cutoff  Alt Code
                                          StartID                      Password
                     LongMult  Long$Inc  StipMult  Stip$Inc            Calendar
                               Override    Factor            UnitType  Op
--------------------------------------------------------------------------------
12 12345678 123  Y   #######*  ########  ########  ########       999  123456789
12 12345678 123  Y   #######*  ########  ########  ########       999  123456789
12 12345678 123  Y   #.######

[] <<Post>> <<Print>> <<Delete>> <<Import>> <<Export>> <<Cancel>> <<Done>>
--------------------------------------------------------------------------------}

implementation uses Windows, ServerController, UserSessionUnit, nsShowYN;

{$R *.dfm}

const SelectC  = 0;  EditC       = 1;  InsertC  = 2;  DeleteC  = 3; CodeC   = 4;
      DescrC   = 5;  ShortDescrC = 6;  IncludeC = 7;  Amount1C = 8; Amount2C= 9;
      Amount3C = 10; Amount4C    = 11; CutoffC  = 12; AltCodeC = 13;

  OK_Click = 0;     Yes_Click = 1;   No_Click = 2;

var   w_min: array [2..11] of byte = (13, 8, 2, 9, 9, 9, 9, 9, 10, 6);


{******************************}
procedure TRefsForm.IWAppFormCreate(Sender: TObject);
  var j1, subapw, colw, row, itemw: integer; s1, titlew: string[100];
    x: double; begin

  Title := 'Object Reference File';
  ItemsAdvGrid.Controller.Caption := '';

{ set_columns; }

  with ItemsAdvGrid{, BudDef^[ref]} do begin
  with Columns[CodeC] do begin WidthType := wtNone;
    begin SubTitle := 'Code';
      Width := 9*Font.Size; end; end;
  with Columns[DescrC] do begin WidthType := wtNone;
    SubTitle := 'Descr';
    begin MaxLength := 40;
      Width := MaxLength*Font.Size; end; end;
  with Columns[ShortDescrC] do  begin
    MaxLength := 17; Width := MaxLength*Font.Size; end;
  Columns[IncludeC].Visible := false;
  Columns[Amount1C].Visible := false;
  Columns[Amount2C].Visible := false;
  Columns[Amount3C].Visible := false;
  Columns[Amount4C].Visible := false;
  Columns[CutoffC].Visible := false;
  Columns[AltCodeC].Visible := false;
  for colw := 0 to Columns.Count-1 do with Columns[colw] do begin
    if Hint='' then ShowHint := false;
    WidthType := wtAbsolute;
    Width := round(Width*1.1);
    end;

{ move_in_list; }

  with SortSettings do begin Direction := sdAscending; Column := CodeC; end;
  TotalRows := 273;
  RowCount := TotalRows;
  for itemw := 0 to TotalRows-1 do begin
    str(itemw,s1);

    while length(s1)<6 do
      s1 := '0'+s1;
    Cells[CodeC,itemw] := s1;
    Cells[DescrC,itemw] := s1 + ' testing';
    Cells[ShortDescrC,itemw] := s1 + ' test'; end;

  Title := 'Object';
  MenuMen.TitleLab.Caption := Title;

  ItemsAdvGrid.TabOrder := 10;
  AllCB.TabOrder := 20;
  OKBtn.TabOrder := 30;
  PrintBtn.TabOrder := 40;
  DeleteBtn.TabOrder := 50;
  ImportBtn.TabOrder := 60;
  ExportBtn.TabOrder := 70;
  CancelBtn.TabOrder := 80;
  DoneBtn.TabOrder := 90;
  MenuMen.TabOrder := 100;
  ActiveControl := ItemsAdvGrid; end; end;

{******************************}
procedure TRefsForm.OKBtnClick(Sender: TObject); begin

 {clear_AdvMessageDial(MenuMen.AdvMessageDial1);}
  with MenuMen.AdvMessageDial1.CustomButtons do begin
    Add('Initialize'); Add('Load'); Add('Save'); Add('Directory');
    Add('Done'); end;
  MenuMen.AdvMessageDial1.Caption := ItemsAdvGrid.Columns[0].SubTitle;
  MenuMen.AdvMessageDial1.CommonButtons := [];
  MenuMen.AdvMessageDial1.Show;
  end;

procedure TRefsForm.OKBtn_handler(Sender: TObject; ModalResult: TModalResult);
  begin
  UserSession.modal_j := 1{success};
  if ModalResult=mrYes then begin {MenuMen.ModalWin.hide; }
    get_ver_authorization_web; end; end;

{******************************}
procedure TRefsForm.get_ver_authorization_web;
  begin with UserSession do begin
  modal_j := 0{false};
  get_ver_authorization_loop; end; end;

procedure TRefsForm.get_ver_authorization_loop;
  begin with MenuMen.AdvMessageDial1 do begin
    Top := 150;
    InputType := itPassword; CommonButtons := [cbOK, cbCancel];
    InputString := '';
    Caption := 'Enter password';
    OnButtonClick := get_ver_authorization_ButtonClick;
    Show; end; end;

procedure TRefsForm.get_ver_authorization_ButtonClick(Sender: TObject;
    ButtonIndex: Integer; InputString, InputPassword: string;
    InputCheck: Boolean; var Allow: Boolean);
  begin with UserSession do begin
    if (ButtonIndex<>OK_Click) and (ButtonIndex<>Yes_Click) then exit;
    if InputPassword>'' then begin {MenuMen.AdvMessageDial1.hide;}
      Trans_Handler(nil); exit; end
    else get_ver_authorization_loop; end; end;

{******************************}
procedure TRefsForm.Trans_Handler(Sender: TObject); begin
  WebApplication.ShowMessage('it works');
  end;

initialization
  TRefsForm.SetAsMainForm;

end.
